# Device Simulator

`devicesimulator` is used to simulate the load generated by devices.

### Setup

Copy the necessary setup files to run a `devicesimulator`.

    mkdir -p ~/.flightctl/certs/ ~/.config/flightctl/
    cp bin/agent/etc/flightctl/certs/* ~/.flightctl/certs/
    cp bin/agent/etc/flightctl/config.yaml ~/.flightctl/agent.yaml

### Running

    bin/devicesimulator --count=1

The device simulator will automatically create a fleet configuration named `simulator-disk-monitoring` if it doesn't already exist.
This eliminates the disk usage errors that would occur with default monitoring configurations.
The fleet uses the selector `created_by: device-simulator` to automatically match all devices created by the simulator.

# Remote simulator

To simulate a large number of devices (10,000 for example) a
`devicesimulator` has to be installed on a number of separate hosts to let it use more resources. Each remote host must be [set up](#remote-setup) with the same files. Then you have to [start simulator](#remote-run) on each host.

### Remote setup

Run the same commands per each host. Note: some commands must be run remotely.

    # on remote host
    mkdir -p ~/.flightctl/certs/ ~/.config/flightctl ~/bin
    scp bin/agent/etc/flightctl/certs/* your_username@remotehost:~/.flightctl/certs/
    scp bin/agent/etc/flightctl/config.yaml your_username@remotehost:~/.flightctl/agent.yaml
    scp ~/.config/flightctl/client.yaml your_username@remotehost:~/.config/flightctl/client.yaml
    scp bin/devicesimulator your_username@remotehost:~/bin/
    # on remote host 
    chmod -R 755 ~/.flightctl/ ~/.config/flightctl bin/devicesimulator

### Remote run

On each remote host run `devicesimulator` with at least two parameters:
* count - number of devices to simulate on this host
* initial-device-index - starting index for device name suffix. To simulate 600 devices on 3 hosts run:
    > bin/devicesimulator --count=200 \# device-00000 to device-00199
    > 
    > bin/devicesimulator --count=200 --initial-device-index=200 \# device-00200 to device-00399
    > 
    > bin/devicesimulator --count=200 --initial-device-index=400 \# device-00400 to device-00599
 
Per each device a `podman event` will be created to consume its events. These tasks will never finish and will consume a considerable amount of memory. As a workaround run the following script on each host:

    #!/bin/bash
    while true; do
      echo pkill -f -TERM 'podman events'
      sudo pkill -f -TERM 'podman events'
      sleep 30
    done

You can also use `-v error` or `-v fatal` flag to limit a lower level of messages to be displayed.
